#region Using declarations
using System;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.ComponentModel;
using System.Xml.Serialization;
using System.Windows.Forms;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{		
		
    /// <summary>
    /// Contador de cuenta atrás
    /// </summary>
    [Description("Contador de cuenta atrás")]
    public class ZiTimer : Indicator
    {
        #region Variables
        // Wizard generated variables
        // User defined variables (add any user defined variables below)
		private bool bInit = true;
		private int lastBar = 0;
		System.Windows.Forms.Timer myTimer = new System.Windows.Forms.Timer();		
		//public delegate void EventHandler(Object sender, EventArgs e);
        #endregion

        /// <summary>
        /// This method is used to configure the indicator and is called once before any bar data is loaded.
        /// </summary>
        protected override void Initialize()
        {
            CalculateOnBarClose	= false;
            Overlay				= true;
            PriceTypeSupported	= false;			
        }

		
		// This is the method to run when the timer is raised.
    	private void TimerEventProcessor(Object sender, EventArgs e) {
			//DrawTextFixed("Timer", DateTime.Now.ToLongTimeString(), TextPosition.TopLeft );
			TriggerCustomEvent(MyCustomHandler, myTimer.Interval);
			//myObject.DrawTextFixed("Timer", DateTime.Now.ToLongTimeString(), TextPosition.TopLeft );
       		//myTimer.Stop();
        	//aTimer.Enabled = true;
       }		
		private void MyCustomHandler(object state){ 
			DrawTextFixed("Timer", DateTime.Now.ToLongTimeString(), TextPosition.TopLeft );
		}

		
		
        /// <summary>
        /// Called on each bar update event (incoming tick)
        /// </summary>
        protected override void OnBarUpdate()
        {							
			if ( Historical ) return;
			
			if ( bInit ){				
				myTimer.Tick += new EventHandler(TimerEventProcessor);
				myTimer.Interval = 1000;
				//myTimer.Enabled = true;
				myTimer.Start();
				//GC.KeepAlive(myTimer);
				bInit = false;
			}
			
            // Use this method for calculating your indicator values. Assign a value to each
            // plot below by replacing 'Close[0]' with your own formula.
			if ( lastBar != CurrentBar ){
				lastBar = CurrentBar;
			}
			
			double v = Bars.Period.Value - ( Bars.Period.Value * Bars.PercentComplete );
			double decimales = v - (int)v;
			double segundos;
			if ( decimales > 0 )
				segundos = (int)(60 * decimales);
			else
				segundos = 0;
			string str = ((int)v).ToString() + " : " + segundos.ToString();
			
			//DrawTextFixed("Timer", str , TextPosition.TopLeft );
			
			
			//DrawTextFixed("Timer", Bars.Period.Value.ToString(), TextPosition.TopLeft );
			//DrawTextFixed( "Timer", DateTime.Now.ToLongTimeString(), TextPosition.TopLeft );
			//DrawTextFixed( "Timer", (Bars.Period.Value * Bars.PercentComplete).ToString(), TextPosition.TopLeft );
			//DrawTextFixed( "Timer", ChartControl.Bounds.Bottom.ToString(), TextPosition.TopLeft );
			//DrawRectangle("RTimer", false, 10, 			
        }

		

	
		public override void Plot(Graphics graphics, Rectangle bounds, double min, double max)
		{
			base.Plot(graphics, bounds, min, max);
			if (Bars == null || ChartControl == null) return;
			
			// Create pen.
		    Pen blackPen = new Pen(Color.Black, 1);
			SolidBrush myBrush = new SolidBrush(Color.Blue);
			
			
			int ancho = 100;
    		// Create rectangle.
    		Rectangle fondo = new Rectangle( bounds.Width-130 , 5, ancho, 6);
			Rectangle barra = new Rectangle( bounds.Width-130 , 5, (int)(ancho*Bars.PercentComplete), 6);
		    // Draw rectangle to screen.
    		graphics.DrawRectangle(blackPen, fondo);
			graphics.FillRectangle(myBrush, barra);
			
			
			
			

			
		}
		
        #region Properties

        #endregion
    }
}

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private ZiTimer[] cacheZiTimer = null;

        private static ZiTimer checkZiTimer = new ZiTimer();

        /// <summary>
        /// Contador de cuenta atrás
        /// </summary>
        /// <returns></returns>
        public ZiTimer ZiTimer()
        {
            return ZiTimer(Input);
        }

        /// <summary>
        /// Contador de cuenta atrás
        /// </summary>
        /// <returns></returns>
        public ZiTimer ZiTimer(Data.IDataSeries input)
        {

            if (cacheZiTimer != null)
                for (int idx = 0; idx < cacheZiTimer.Length; idx++)
                    if (cacheZiTimer[idx].EqualsInput(input))
                        return cacheZiTimer[idx];

            ZiTimer indicator = new ZiTimer();
            indicator.BarsRequired = BarsRequired;
            indicator.CalculateOnBarClose = CalculateOnBarClose;
            indicator.Input = input;
            indicator.SetUp();

            ZiTimer[] tmp = new ZiTimer[cacheZiTimer == null ? 1 : cacheZiTimer.Length + 1];
            if (cacheZiTimer != null)
                cacheZiTimer.CopyTo(tmp, 0);
            tmp[tmp.Length - 1] = indicator;
            cacheZiTimer = tmp;
            Indicators.Add(indicator);

            return indicator;
        }

    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Contador de cuenta atrás
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ZiTimer ZiTimer()
        {
            return _indicator.ZiTimer(Input);
        }

        /// <summary>
        /// Contador de cuenta atrás
        /// </summary>
        /// <returns></returns>
        public Indicator.ZiTimer ZiTimer(Data.IDataSeries input)
        {
            return _indicator.ZiTimer(input);
        }

    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Contador de cuenta atrás
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ZiTimer ZiTimer()
        {
            return _indicator.ZiTimer(Input);
        }

        /// <summary>
        /// Contador de cuenta atrás
        /// </summary>
        /// <returns></returns>
        public Indicator.ZiTimer ZiTimer(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.ZiTimer(input);
        }

    }
}
#endregion
